
user/_stressfs:     file format elf64-littleriscv


Disassembly of section .text:

0000000000000000 <main>:
#include "kernel/fs.h"
#include "kernel/fcntl.h"

int
main(int argc, char *argv[])
{
   0:	dc010113          	addi	sp,sp,-576
   4:	22113c23          	sd	ra,568(sp)
   8:	22813823          	sd	s0,560(sp)
   c:	0480                	addi	s0,sp,576
   e:	87aa                	mv	a5,a0
  10:	dcb43023          	sd	a1,-576(s0)
  14:	dcf42623          	sw	a5,-564(s0)
  int fd, i;
  char path[] = "stressfs0";
  18:	00001797          	auipc	a5,0x1
  1c:	f2878793          	addi	a5,a5,-216 # f40 <malloc+0x174>
  20:	6398                	ld	a4,0(a5)
  22:	fce43c23          	sd	a4,-40(s0)
  26:	0087d783          	lhu	a5,8(a5)
  2a:	fef41023          	sh	a5,-32(s0)
  char data[512];

  printf("stressfs starting\n");
  2e:	00001517          	auipc	a0,0x1
  32:	ee250513          	addi	a0,a0,-286 # f10 <malloc+0x144>
  36:	00001097          	auipc	ra,0x1
  3a:	ba4080e7          	jalr	-1116(ra) # bda <printf>
  memset(data, 'a', sizeof(data));
  3e:	dd840793          	addi	a5,s0,-552
  42:	20000613          	li	a2,512
  46:	06100593          	li	a1,97
  4a:	853e                	mv	a0,a5
  4c:	00000097          	auipc	ra,0x0
  50:	224080e7          	jalr	548(ra) # 270 <memset>

  for(i = 0; i < 4; i++)
  54:	fe042623          	sw	zero,-20(s0)
  58:	a829                	j	72 <main+0x72>
    if(fork() > 0)
  5a:	00000097          	auipc	ra,0x0
  5e:	63a080e7          	jalr	1594(ra) # 694 <fork>
  62:	87aa                	mv	a5,a0
  64:	00f04f63          	bgtz	a5,82 <main+0x82>
  for(i = 0; i < 4; i++)
  68:	fec42783          	lw	a5,-20(s0)
  6c:	2785                	addiw	a5,a5,1
  6e:	fef42623          	sw	a5,-20(s0)
  72:	fec42783          	lw	a5,-20(s0)
  76:	0007871b          	sext.w	a4,a5
  7a:	478d                	li	a5,3
  7c:	fce7dfe3          	bge	a5,a4,5a <main+0x5a>
  80:	a011                	j	84 <main+0x84>
      break;
  82:	0001                	nop

  printf("write %d\n", i);
  84:	fec42783          	lw	a5,-20(s0)
  88:	85be                	mv	a1,a5
  8a:	00001517          	auipc	a0,0x1
  8e:	e9e50513          	addi	a0,a0,-354 # f28 <malloc+0x15c>
  92:	00001097          	auipc	ra,0x1
  96:	b48080e7          	jalr	-1208(ra) # bda <printf>

  path[8] += i;
  9a:	fe044703          	lbu	a4,-32(s0)
  9e:	fec42783          	lw	a5,-20(s0)
  a2:	0ff7f793          	andi	a5,a5,255
  a6:	9fb9                	addw	a5,a5,a4
  a8:	0ff7f793          	andi	a5,a5,255
  ac:	fef40023          	sb	a5,-32(s0)
  fd = open(path, O_CREATE | O_RDWR);
  b0:	fd840793          	addi	a5,s0,-40
  b4:	20200593          	li	a1,514
  b8:	853e                	mv	a0,a5
  ba:	00000097          	auipc	ra,0x0
  be:	622080e7          	jalr	1570(ra) # 6dc <open>
  c2:	87aa                	mv	a5,a0
  c4:	fef42423          	sw	a5,-24(s0)
  for(i = 0; i < 20; i++)
  c8:	fe042623          	sw	zero,-20(s0)
  cc:	a015                	j	f0 <main+0xf0>
//    printf(fd, "%d\n", i);
    write(fd, data, sizeof(data));
  ce:	dd840713          	addi	a4,s0,-552
  d2:	fe842783          	lw	a5,-24(s0)
  d6:	20000613          	li	a2,512
  da:	85ba                	mv	a1,a4
  dc:	853e                	mv	a0,a5
  de:	00000097          	auipc	ra,0x0
  e2:	5de080e7          	jalr	1502(ra) # 6bc <write>
  for(i = 0; i < 20; i++)
  e6:	fec42783          	lw	a5,-20(s0)
  ea:	2785                	addiw	a5,a5,1
  ec:	fef42623          	sw	a5,-20(s0)
  f0:	fec42783          	lw	a5,-20(s0)
  f4:	0007871b          	sext.w	a4,a5
  f8:	47cd                	li	a5,19
  fa:	fce7dae3          	bge	a5,a4,ce <main+0xce>
  close(fd);
  fe:	fe842783          	lw	a5,-24(s0)
 102:	853e                	mv	a0,a5
 104:	00000097          	auipc	ra,0x0
 108:	5c0080e7          	jalr	1472(ra) # 6c4 <close>

  printf("read\n");
 10c:	00001517          	auipc	a0,0x1
 110:	e2c50513          	addi	a0,a0,-468 # f38 <malloc+0x16c>
 114:	00001097          	auipc	ra,0x1
 118:	ac6080e7          	jalr	-1338(ra) # bda <printf>

  fd = open(path, O_RDONLY);
 11c:	fd840793          	addi	a5,s0,-40
 120:	4581                	li	a1,0
 122:	853e                	mv	a0,a5
 124:	00000097          	auipc	ra,0x0
 128:	5b8080e7          	jalr	1464(ra) # 6dc <open>
 12c:	87aa                	mv	a5,a0
 12e:	fef42423          	sw	a5,-24(s0)
  for (i = 0; i < 20; i++)
 132:	fe042623          	sw	zero,-20(s0)
 136:	a015                	j	15a <main+0x15a>
    read(fd, data, sizeof(data));
 138:	dd840713          	addi	a4,s0,-552
 13c:	fe842783          	lw	a5,-24(s0)
 140:	20000613          	li	a2,512
 144:	85ba                	mv	a1,a4
 146:	853e                	mv	a0,a5
 148:	00000097          	auipc	ra,0x0
 14c:	56c080e7          	jalr	1388(ra) # 6b4 <read>
  for (i = 0; i < 20; i++)
 150:	fec42783          	lw	a5,-20(s0)
 154:	2785                	addiw	a5,a5,1
 156:	fef42623          	sw	a5,-20(s0)
 15a:	fec42783          	lw	a5,-20(s0)
 15e:	0007871b          	sext.w	a4,a5
 162:	47cd                	li	a5,19
 164:	fce7dae3          	bge	a5,a4,138 <main+0x138>
  close(fd);
 168:	fe842783          	lw	a5,-24(s0)
 16c:	853e                	mv	a0,a5
 16e:	00000097          	auipc	ra,0x0
 172:	556080e7          	jalr	1366(ra) # 6c4 <close>

  wait(0);
 176:	4501                	li	a0,0
 178:	00000097          	auipc	ra,0x0
 17c:	52c080e7          	jalr	1324(ra) # 6a4 <wait>

  exit(0);
 180:	4501                	li	a0,0
 182:	00000097          	auipc	ra,0x0
 186:	51a080e7          	jalr	1306(ra) # 69c <exit>

000000000000018a <strcpy>:
#include "kernel/fcntl.h"
#include "user/user.h"

char*
strcpy(char *s, const char *t)
{
 18a:	7179                	addi	sp,sp,-48
 18c:	f422                	sd	s0,40(sp)
 18e:	1800                	addi	s0,sp,48
 190:	fca43c23          	sd	a0,-40(s0)
 194:	fcb43823          	sd	a1,-48(s0)
  char *os;

  os = s;
 198:	fd843783          	ld	a5,-40(s0)
 19c:	fef43423          	sd	a5,-24(s0)
  while((*s++ = *t++) != 0)
 1a0:	0001                	nop
 1a2:	fd043703          	ld	a4,-48(s0)
 1a6:	00170793          	addi	a5,a4,1
 1aa:	fcf43823          	sd	a5,-48(s0)
 1ae:	fd843783          	ld	a5,-40(s0)
 1b2:	00178693          	addi	a3,a5,1
 1b6:	fcd43c23          	sd	a3,-40(s0)
 1ba:	00074703          	lbu	a4,0(a4)
 1be:	00e78023          	sb	a4,0(a5)
 1c2:	0007c783          	lbu	a5,0(a5)
 1c6:	fff1                	bnez	a5,1a2 <strcpy+0x18>
    ;
  return os;
 1c8:	fe843783          	ld	a5,-24(s0)
}
 1cc:	853e                	mv	a0,a5
 1ce:	7422                	ld	s0,40(sp)
 1d0:	6145                	addi	sp,sp,48
 1d2:	8082                	ret

00000000000001d4 <strcmp>:

int
strcmp(const char *p, const char *q)
{
 1d4:	1101                	addi	sp,sp,-32
 1d6:	ec22                	sd	s0,24(sp)
 1d8:	1000                	addi	s0,sp,32
 1da:	fea43423          	sd	a0,-24(s0)
 1de:	feb43023          	sd	a1,-32(s0)
  while(*p && *p == *q)
 1e2:	a819                	j	1f8 <strcmp+0x24>
    p++, q++;
 1e4:	fe843783          	ld	a5,-24(s0)
 1e8:	0785                	addi	a5,a5,1
 1ea:	fef43423          	sd	a5,-24(s0)
 1ee:	fe043783          	ld	a5,-32(s0)
 1f2:	0785                	addi	a5,a5,1
 1f4:	fef43023          	sd	a5,-32(s0)
  while(*p && *p == *q)
 1f8:	fe843783          	ld	a5,-24(s0)
 1fc:	0007c783          	lbu	a5,0(a5)
 200:	cb99                	beqz	a5,216 <strcmp+0x42>
 202:	fe843783          	ld	a5,-24(s0)
 206:	0007c703          	lbu	a4,0(a5)
 20a:	fe043783          	ld	a5,-32(s0)
 20e:	0007c783          	lbu	a5,0(a5)
 212:	fcf709e3          	beq	a4,a5,1e4 <strcmp+0x10>
  return (uchar)*p - (uchar)*q;
 216:	fe843783          	ld	a5,-24(s0)
 21a:	0007c783          	lbu	a5,0(a5)
 21e:	0007871b          	sext.w	a4,a5
 222:	fe043783          	ld	a5,-32(s0)
 226:	0007c783          	lbu	a5,0(a5)
 22a:	2781                	sext.w	a5,a5
 22c:	40f707bb          	subw	a5,a4,a5
 230:	2781                	sext.w	a5,a5
}
 232:	853e                	mv	a0,a5
 234:	6462                	ld	s0,24(sp)
 236:	6105                	addi	sp,sp,32
 238:	8082                	ret

000000000000023a <strlen>:

uint
strlen(const char *s)
{
 23a:	7179                	addi	sp,sp,-48
 23c:	f422                	sd	s0,40(sp)
 23e:	1800                	addi	s0,sp,48
 240:	fca43c23          	sd	a0,-40(s0)
  int n;

  for(n = 0; s[n]; n++)
 244:	fe042623          	sw	zero,-20(s0)
 248:	a031                	j	254 <strlen+0x1a>
 24a:	fec42783          	lw	a5,-20(s0)
 24e:	2785                	addiw	a5,a5,1
 250:	fef42623          	sw	a5,-20(s0)
 254:	fec42783          	lw	a5,-20(s0)
 258:	fd843703          	ld	a4,-40(s0)
 25c:	97ba                	add	a5,a5,a4
 25e:	0007c783          	lbu	a5,0(a5)
 262:	f7e5                	bnez	a5,24a <strlen+0x10>
    ;
  return n;
 264:	fec42783          	lw	a5,-20(s0)
}
 268:	853e                	mv	a0,a5
 26a:	7422                	ld	s0,40(sp)
 26c:	6145                	addi	sp,sp,48
 26e:	8082                	ret

0000000000000270 <memset>:

void*
memset(void *dst, int c, uint n)
{
 270:	7179                	addi	sp,sp,-48
 272:	f422                	sd	s0,40(sp)
 274:	1800                	addi	s0,sp,48
 276:	fca43c23          	sd	a0,-40(s0)
 27a:	87ae                	mv	a5,a1
 27c:	8732                	mv	a4,a2
 27e:	fcf42a23          	sw	a5,-44(s0)
 282:	87ba                	mv	a5,a4
 284:	fcf42823          	sw	a5,-48(s0)
  char *cdst = (char *) dst;
 288:	fd843783          	ld	a5,-40(s0)
 28c:	fef43023          	sd	a5,-32(s0)
  int i;
  for(i = 0; i < n; i++){
 290:	fe042623          	sw	zero,-20(s0)
 294:	a00d                	j	2b6 <memset+0x46>
    cdst[i] = c;
 296:	fec42783          	lw	a5,-20(s0)
 29a:	fe043703          	ld	a4,-32(s0)
 29e:	97ba                	add	a5,a5,a4
 2a0:	fd442703          	lw	a4,-44(s0)
 2a4:	0ff77713          	andi	a4,a4,255
 2a8:	00e78023          	sb	a4,0(a5)
  for(i = 0; i < n; i++){
 2ac:	fec42783          	lw	a5,-20(s0)
 2b0:	2785                	addiw	a5,a5,1
 2b2:	fef42623          	sw	a5,-20(s0)
 2b6:	fec42703          	lw	a4,-20(s0)
 2ba:	fd042783          	lw	a5,-48(s0)
 2be:	2781                	sext.w	a5,a5
 2c0:	fcf76be3          	bltu	a4,a5,296 <memset+0x26>
  }
  return dst;
 2c4:	fd843783          	ld	a5,-40(s0)
}
 2c8:	853e                	mv	a0,a5
 2ca:	7422                	ld	s0,40(sp)
 2cc:	6145                	addi	sp,sp,48
 2ce:	8082                	ret

00000000000002d0 <strchr>:

char*
strchr(const char *s, char c)
{
 2d0:	1101                	addi	sp,sp,-32
 2d2:	ec22                	sd	s0,24(sp)
 2d4:	1000                	addi	s0,sp,32
 2d6:	fea43423          	sd	a0,-24(s0)
 2da:	87ae                	mv	a5,a1
 2dc:	fef403a3          	sb	a5,-25(s0)
  for(; *s; s++)
 2e0:	a01d                	j	306 <strchr+0x36>
    if(*s == c)
 2e2:	fe843783          	ld	a5,-24(s0)
 2e6:	0007c703          	lbu	a4,0(a5)
 2ea:	fe744783          	lbu	a5,-25(s0)
 2ee:	0ff7f793          	andi	a5,a5,255
 2f2:	00e79563          	bne	a5,a4,2fc <strchr+0x2c>
      return (char*)s;
 2f6:	fe843783          	ld	a5,-24(s0)
 2fa:	a821                	j	312 <strchr+0x42>
  for(; *s; s++)
 2fc:	fe843783          	ld	a5,-24(s0)
 300:	0785                	addi	a5,a5,1
 302:	fef43423          	sd	a5,-24(s0)
 306:	fe843783          	ld	a5,-24(s0)
 30a:	0007c783          	lbu	a5,0(a5)
 30e:	fbf1                	bnez	a5,2e2 <strchr+0x12>
  return 0;
 310:	4781                	li	a5,0
}
 312:	853e                	mv	a0,a5
 314:	6462                	ld	s0,24(sp)
 316:	6105                	addi	sp,sp,32
 318:	8082                	ret

000000000000031a <gets>:

char*
gets(char *buf, int max)
{
 31a:	7179                	addi	sp,sp,-48
 31c:	f406                	sd	ra,40(sp)
 31e:	f022                	sd	s0,32(sp)
 320:	1800                	addi	s0,sp,48
 322:	fca43c23          	sd	a0,-40(s0)
 326:	87ae                	mv	a5,a1
 328:	fcf42a23          	sw	a5,-44(s0)
  int i, cc;
  char c;

  for(i=0; i+1 < max; ){
 32c:	fe042623          	sw	zero,-20(s0)
 330:	a8a1                	j	388 <gets+0x6e>
    cc = read(0, &c, 1);
 332:	fe740793          	addi	a5,s0,-25
 336:	4605                	li	a2,1
 338:	85be                	mv	a1,a5
 33a:	4501                	li	a0,0
 33c:	00000097          	auipc	ra,0x0
 340:	378080e7          	jalr	888(ra) # 6b4 <read>
 344:	87aa                	mv	a5,a0
 346:	fef42423          	sw	a5,-24(s0)
    if(cc < 1)
 34a:	fe842783          	lw	a5,-24(s0)
 34e:	2781                	sext.w	a5,a5
 350:	04f05763          	blez	a5,39e <gets+0x84>
      break;
    buf[i++] = c;
 354:	fec42783          	lw	a5,-20(s0)
 358:	0017871b          	addiw	a4,a5,1
 35c:	fee42623          	sw	a4,-20(s0)
 360:	873e                	mv	a4,a5
 362:	fd843783          	ld	a5,-40(s0)
 366:	97ba                	add	a5,a5,a4
 368:	fe744703          	lbu	a4,-25(s0)
 36c:	00e78023          	sb	a4,0(a5)
    if(c == '\n' || c == '\r')
 370:	fe744783          	lbu	a5,-25(s0)
 374:	873e                	mv	a4,a5
 376:	47a9                	li	a5,10
 378:	02f70463          	beq	a4,a5,3a0 <gets+0x86>
 37c:	fe744783          	lbu	a5,-25(s0)
 380:	873e                	mv	a4,a5
 382:	47b5                	li	a5,13
 384:	00f70e63          	beq	a4,a5,3a0 <gets+0x86>
  for(i=0; i+1 < max; ){
 388:	fec42783          	lw	a5,-20(s0)
 38c:	2785                	addiw	a5,a5,1
 38e:	0007871b          	sext.w	a4,a5
 392:	fd442783          	lw	a5,-44(s0)
 396:	2781                	sext.w	a5,a5
 398:	f8f74de3          	blt	a4,a5,332 <gets+0x18>
 39c:	a011                	j	3a0 <gets+0x86>
      break;
 39e:	0001                	nop
      break;
  }
  buf[i] = '\0';
 3a0:	fec42783          	lw	a5,-20(s0)
 3a4:	fd843703          	ld	a4,-40(s0)
 3a8:	97ba                	add	a5,a5,a4
 3aa:	00078023          	sb	zero,0(a5)
  return buf;
 3ae:	fd843783          	ld	a5,-40(s0)
}
 3b2:	853e                	mv	a0,a5
 3b4:	70a2                	ld	ra,40(sp)
 3b6:	7402                	ld	s0,32(sp)
 3b8:	6145                	addi	sp,sp,48
 3ba:	8082                	ret

00000000000003bc <stat>:

int
stat(const char *n, struct stat *st)
{
 3bc:	7179                	addi	sp,sp,-48
 3be:	f406                	sd	ra,40(sp)
 3c0:	f022                	sd	s0,32(sp)
 3c2:	1800                	addi	s0,sp,48
 3c4:	fca43c23          	sd	a0,-40(s0)
 3c8:	fcb43823          	sd	a1,-48(s0)
  int fd;
  int r;

  fd = open(n, O_RDONLY);
 3cc:	4581                	li	a1,0
 3ce:	fd843503          	ld	a0,-40(s0)
 3d2:	00000097          	auipc	ra,0x0
 3d6:	30a080e7          	jalr	778(ra) # 6dc <open>
 3da:	87aa                	mv	a5,a0
 3dc:	fef42623          	sw	a5,-20(s0)
  if(fd < 0)
 3e0:	fec42783          	lw	a5,-20(s0)
 3e4:	2781                	sext.w	a5,a5
 3e6:	0007d463          	bgez	a5,3ee <stat+0x32>
    return -1;
 3ea:	57fd                	li	a5,-1
 3ec:	a035                	j	418 <stat+0x5c>
  r = fstat(fd, st);
 3ee:	fec42783          	lw	a5,-20(s0)
 3f2:	fd043583          	ld	a1,-48(s0)
 3f6:	853e                	mv	a0,a5
 3f8:	00000097          	auipc	ra,0x0
 3fc:	2fc080e7          	jalr	764(ra) # 6f4 <fstat>
 400:	87aa                	mv	a5,a0
 402:	fef42423          	sw	a5,-24(s0)
  close(fd);
 406:	fec42783          	lw	a5,-20(s0)
 40a:	853e                	mv	a0,a5
 40c:	00000097          	auipc	ra,0x0
 410:	2b8080e7          	jalr	696(ra) # 6c4 <close>
  return r;
 414:	fe842783          	lw	a5,-24(s0)
}
 418:	853e                	mv	a0,a5
 41a:	70a2                	ld	ra,40(sp)
 41c:	7402                	ld	s0,32(sp)
 41e:	6145                	addi	sp,sp,48
 420:	8082                	ret

0000000000000422 <atoi>:

int
atoi(const char *s)
{
 422:	7179                	addi	sp,sp,-48
 424:	f422                	sd	s0,40(sp)
 426:	1800                	addi	s0,sp,48
 428:	fca43c23          	sd	a0,-40(s0)
  int n;

  n = 0;
 42c:	fe042623          	sw	zero,-20(s0)
  while('0' <= *s && *s <= '9')
 430:	a815                	j	464 <atoi+0x42>
    n = n*10 + *s++ - '0';
 432:	fec42703          	lw	a4,-20(s0)
 436:	87ba                	mv	a5,a4
 438:	0027979b          	slliw	a5,a5,0x2
 43c:	9fb9                	addw	a5,a5,a4
 43e:	0017979b          	slliw	a5,a5,0x1
 442:	0007871b          	sext.w	a4,a5
 446:	fd843783          	ld	a5,-40(s0)
 44a:	00178693          	addi	a3,a5,1
 44e:	fcd43c23          	sd	a3,-40(s0)
 452:	0007c783          	lbu	a5,0(a5)
 456:	2781                	sext.w	a5,a5
 458:	9fb9                	addw	a5,a5,a4
 45a:	2781                	sext.w	a5,a5
 45c:	fd07879b          	addiw	a5,a5,-48
 460:	fef42623          	sw	a5,-20(s0)
  while('0' <= *s && *s <= '9')
 464:	fd843783          	ld	a5,-40(s0)
 468:	0007c783          	lbu	a5,0(a5)
 46c:	873e                	mv	a4,a5
 46e:	02f00793          	li	a5,47
 472:	00e7fb63          	bgeu	a5,a4,488 <atoi+0x66>
 476:	fd843783          	ld	a5,-40(s0)
 47a:	0007c783          	lbu	a5,0(a5)
 47e:	873e                	mv	a4,a5
 480:	03900793          	li	a5,57
 484:	fae7f7e3          	bgeu	a5,a4,432 <atoi+0x10>
  return n;
 488:	fec42783          	lw	a5,-20(s0)
}
 48c:	853e                	mv	a0,a5
 48e:	7422                	ld	s0,40(sp)
 490:	6145                	addi	sp,sp,48
 492:	8082                	ret

0000000000000494 <memmove>:

void*
memmove(void *vdst, const void *vsrc, int n)
{
 494:	7139                	addi	sp,sp,-64
 496:	fc22                	sd	s0,56(sp)
 498:	0080                	addi	s0,sp,64
 49a:	fca43c23          	sd	a0,-40(s0)
 49e:	fcb43823          	sd	a1,-48(s0)
 4a2:	87b2                	mv	a5,a2
 4a4:	fcf42623          	sw	a5,-52(s0)
  char *dst;
  const char *src;

  dst = vdst;
 4a8:	fd843783          	ld	a5,-40(s0)
 4ac:	fef43423          	sd	a5,-24(s0)
  src = vsrc;
 4b0:	fd043783          	ld	a5,-48(s0)
 4b4:	fef43023          	sd	a5,-32(s0)
  if (src > dst) {
 4b8:	fe043703          	ld	a4,-32(s0)
 4bc:	fe843783          	ld	a5,-24(s0)
 4c0:	02e7fc63          	bgeu	a5,a4,4f8 <memmove+0x64>
    while(n-- > 0)
 4c4:	a00d                	j	4e6 <memmove+0x52>
      *dst++ = *src++;
 4c6:	fe043703          	ld	a4,-32(s0)
 4ca:	00170793          	addi	a5,a4,1
 4ce:	fef43023          	sd	a5,-32(s0)
 4d2:	fe843783          	ld	a5,-24(s0)
 4d6:	00178693          	addi	a3,a5,1
 4da:	fed43423          	sd	a3,-24(s0)
 4de:	00074703          	lbu	a4,0(a4)
 4e2:	00e78023          	sb	a4,0(a5)
    while(n-- > 0)
 4e6:	fcc42783          	lw	a5,-52(s0)
 4ea:	fff7871b          	addiw	a4,a5,-1
 4ee:	fce42623          	sw	a4,-52(s0)
 4f2:	fcf04ae3          	bgtz	a5,4c6 <memmove+0x32>
 4f6:	a891                	j	54a <memmove+0xb6>
  } else {
    dst += n;
 4f8:	fcc42783          	lw	a5,-52(s0)
 4fc:	fe843703          	ld	a4,-24(s0)
 500:	97ba                	add	a5,a5,a4
 502:	fef43423          	sd	a5,-24(s0)
    src += n;
 506:	fcc42783          	lw	a5,-52(s0)
 50a:	fe043703          	ld	a4,-32(s0)
 50e:	97ba                	add	a5,a5,a4
 510:	fef43023          	sd	a5,-32(s0)
    while(n-- > 0)
 514:	a01d                	j	53a <memmove+0xa6>
      *--dst = *--src;
 516:	fe043783          	ld	a5,-32(s0)
 51a:	17fd                	addi	a5,a5,-1
 51c:	fef43023          	sd	a5,-32(s0)
 520:	fe843783          	ld	a5,-24(s0)
 524:	17fd                	addi	a5,a5,-1
 526:	fef43423          	sd	a5,-24(s0)
 52a:	fe043783          	ld	a5,-32(s0)
 52e:	0007c703          	lbu	a4,0(a5)
 532:	fe843783          	ld	a5,-24(s0)
 536:	00e78023          	sb	a4,0(a5)
    while(n-- > 0)
 53a:	fcc42783          	lw	a5,-52(s0)
 53e:	fff7871b          	addiw	a4,a5,-1
 542:	fce42623          	sw	a4,-52(s0)
 546:	fcf048e3          	bgtz	a5,516 <memmove+0x82>
  }
  return vdst;
 54a:	fd843783          	ld	a5,-40(s0)
}
 54e:	853e                	mv	a0,a5
 550:	7462                	ld	s0,56(sp)
 552:	6121                	addi	sp,sp,64
 554:	8082                	ret

0000000000000556 <strconcat>:

void * strconcat(void *vdst, const void *src1, const void *src2){
 556:	7139                	addi	sp,sp,-64
 558:	fc06                	sd	ra,56(sp)
 55a:	f822                	sd	s0,48(sp)
 55c:	0080                	addi	s0,sp,64
 55e:	fca43c23          	sd	a0,-40(s0)
 562:	fcb43823          	sd	a1,-48(s0)
 566:	fcc43423          	sd	a2,-56(s0)
  int src1Len = strlen(src1);
 56a:	fd043503          	ld	a0,-48(s0)
 56e:	00000097          	auipc	ra,0x0
 572:	ccc080e7          	jalr	-820(ra) # 23a <strlen>
 576:	87aa                	mv	a5,a0
 578:	2781                	sext.w	a5,a5
 57a:	fef42623          	sw	a5,-20(s0)
  int src2Len = strlen(src2);
 57e:	fc843503          	ld	a0,-56(s0)
 582:	00000097          	auipc	ra,0x0
 586:	cb8080e7          	jalr	-840(ra) # 23a <strlen>
 58a:	87aa                	mv	a5,a0
 58c:	2781                	sext.w	a5,a5
 58e:	fef42423          	sw	a5,-24(s0)
  memmove(vdst, src1, src1Len);
 592:	fec42783          	lw	a5,-20(s0)
 596:	863e                	mv	a2,a5
 598:	fd043583          	ld	a1,-48(s0)
 59c:	fd843503          	ld	a0,-40(s0)
 5a0:	00000097          	auipc	ra,0x0
 5a4:	ef4080e7          	jalr	-268(ra) # 494 <memmove>
  memmove(vdst+src1Len, src2, src2Len+1);
 5a8:	fec42783          	lw	a5,-20(s0)
 5ac:	fd843703          	ld	a4,-40(s0)
 5b0:	973e                	add	a4,a4,a5
 5b2:	fe842783          	lw	a5,-24(s0)
 5b6:	2785                	addiw	a5,a5,1
 5b8:	2781                	sext.w	a5,a5
 5ba:	863e                	mv	a2,a5
 5bc:	fc843583          	ld	a1,-56(s0)
 5c0:	853a                	mv	a0,a4
 5c2:	00000097          	auipc	ra,0x0
 5c6:	ed2080e7          	jalr	-302(ra) # 494 <memmove>

  return vdst;
 5ca:	fd843783          	ld	a5,-40(s0)
}
 5ce:	853e                	mv	a0,a5
 5d0:	70e2                	ld	ra,56(sp)
 5d2:	7442                	ld	s0,48(sp)
 5d4:	6121                	addi	sp,sp,64
 5d6:	8082                	ret

00000000000005d8 <memcmp>:

int
memcmp(const void *s1, const void *s2, uint n)
{
 5d8:	7139                	addi	sp,sp,-64
 5da:	fc22                	sd	s0,56(sp)
 5dc:	0080                	addi	s0,sp,64
 5de:	fca43c23          	sd	a0,-40(s0)
 5e2:	fcb43823          	sd	a1,-48(s0)
 5e6:	87b2                	mv	a5,a2
 5e8:	fcf42623          	sw	a5,-52(s0)
  const char *p1 = s1, *p2 = s2;
 5ec:	fd843783          	ld	a5,-40(s0)
 5f0:	fef43423          	sd	a5,-24(s0)
 5f4:	fd043783          	ld	a5,-48(s0)
 5f8:	fef43023          	sd	a5,-32(s0)
  while (n-- > 0) {
 5fc:	a0a1                	j	644 <memcmp+0x6c>
    if (*p1 != *p2) {
 5fe:	fe843783          	ld	a5,-24(s0)
 602:	0007c703          	lbu	a4,0(a5)
 606:	fe043783          	ld	a5,-32(s0)
 60a:	0007c783          	lbu	a5,0(a5)
 60e:	02f70163          	beq	a4,a5,630 <memcmp+0x58>
      return *p1 - *p2;
 612:	fe843783          	ld	a5,-24(s0)
 616:	0007c783          	lbu	a5,0(a5)
 61a:	0007871b          	sext.w	a4,a5
 61e:	fe043783          	ld	a5,-32(s0)
 622:	0007c783          	lbu	a5,0(a5)
 626:	2781                	sext.w	a5,a5
 628:	40f707bb          	subw	a5,a4,a5
 62c:	2781                	sext.w	a5,a5
 62e:	a01d                	j	654 <memcmp+0x7c>
    }
    p1++;
 630:	fe843783          	ld	a5,-24(s0)
 634:	0785                	addi	a5,a5,1
 636:	fef43423          	sd	a5,-24(s0)
    p2++;
 63a:	fe043783          	ld	a5,-32(s0)
 63e:	0785                	addi	a5,a5,1
 640:	fef43023          	sd	a5,-32(s0)
  while (n-- > 0) {
 644:	fcc42783          	lw	a5,-52(s0)
 648:	fff7871b          	addiw	a4,a5,-1
 64c:	fce42623          	sw	a4,-52(s0)
 650:	f7dd                	bnez	a5,5fe <memcmp+0x26>
  }
  return 0;
 652:	4781                	li	a5,0
}
 654:	853e                	mv	a0,a5
 656:	7462                	ld	s0,56(sp)
 658:	6121                	addi	sp,sp,64
 65a:	8082                	ret

000000000000065c <memcpy>:

void *
memcpy(void *dst, const void *src, uint n)
{
 65c:	7179                	addi	sp,sp,-48
 65e:	f406                	sd	ra,40(sp)
 660:	f022                	sd	s0,32(sp)
 662:	1800                	addi	s0,sp,48
 664:	fea43423          	sd	a0,-24(s0)
 668:	feb43023          	sd	a1,-32(s0)
 66c:	87b2                	mv	a5,a2
 66e:	fcf42e23          	sw	a5,-36(s0)
  return memmove(dst, src, n);
 672:	fdc42783          	lw	a5,-36(s0)
 676:	863e                	mv	a2,a5
 678:	fe043583          	ld	a1,-32(s0)
 67c:	fe843503          	ld	a0,-24(s0)
 680:	00000097          	auipc	ra,0x0
 684:	e14080e7          	jalr	-492(ra) # 494 <memmove>
 688:	87aa                	mv	a5,a0
}
 68a:	853e                	mv	a0,a5
 68c:	70a2                	ld	ra,40(sp)
 68e:	7402                	ld	s0,32(sp)
 690:	6145                	addi	sp,sp,48
 692:	8082                	ret

0000000000000694 <fork>:
# generated by usys.pl - do not edit
#include "kernel/syscall.h"
.global fork
fork:
 li a7, SYS_fork
 694:	4885                	li	a7,1
 ecall
 696:	00000073          	ecall
 ret
 69a:	8082                	ret

000000000000069c <exit>:
.global exit
exit:
 li a7, SYS_exit
 69c:	4889                	li	a7,2
 ecall
 69e:	00000073          	ecall
 ret
 6a2:	8082                	ret

00000000000006a4 <wait>:
.global wait
wait:
 li a7, SYS_wait
 6a4:	488d                	li	a7,3
 ecall
 6a6:	00000073          	ecall
 ret
 6aa:	8082                	ret

00000000000006ac <pipe>:
.global pipe
pipe:
 li a7, SYS_pipe
 6ac:	4891                	li	a7,4
 ecall
 6ae:	00000073          	ecall
 ret
 6b2:	8082                	ret

00000000000006b4 <read>:
.global read
read:
 li a7, SYS_read
 6b4:	4895                	li	a7,5
 ecall
 6b6:	00000073          	ecall
 ret
 6ba:	8082                	ret

00000000000006bc <write>:
.global write
write:
 li a7, SYS_write
 6bc:	48c1                	li	a7,16
 ecall
 6be:	00000073          	ecall
 ret
 6c2:	8082                	ret

00000000000006c4 <close>:
.global close
close:
 li a7, SYS_close
 6c4:	48d5                	li	a7,21
 ecall
 6c6:	00000073          	ecall
 ret
 6ca:	8082                	ret

00000000000006cc <kill>:
.global kill
kill:
 li a7, SYS_kill
 6cc:	4899                	li	a7,6
 ecall
 6ce:	00000073          	ecall
 ret
 6d2:	8082                	ret

00000000000006d4 <exec>:
.global exec
exec:
 li a7, SYS_exec
 6d4:	489d                	li	a7,7
 ecall
 6d6:	00000073          	ecall
 ret
 6da:	8082                	ret

00000000000006dc <open>:
.global open
open:
 li a7, SYS_open
 6dc:	48bd                	li	a7,15
 ecall
 6de:	00000073          	ecall
 ret
 6e2:	8082                	ret

00000000000006e4 <mknod>:
.global mknod
mknod:
 li a7, SYS_mknod
 6e4:	48c5                	li	a7,17
 ecall
 6e6:	00000073          	ecall
 ret
 6ea:	8082                	ret

00000000000006ec <unlink>:
.global unlink
unlink:
 li a7, SYS_unlink
 6ec:	48c9                	li	a7,18
 ecall
 6ee:	00000073          	ecall
 ret
 6f2:	8082                	ret

00000000000006f4 <fstat>:
.global fstat
fstat:
 li a7, SYS_fstat
 6f4:	48a1                	li	a7,8
 ecall
 6f6:	00000073          	ecall
 ret
 6fa:	8082                	ret

00000000000006fc <link>:
.global link
link:
 li a7, SYS_link
 6fc:	48cd                	li	a7,19
 ecall
 6fe:	00000073          	ecall
 ret
 702:	8082                	ret

0000000000000704 <mkdir>:
.global mkdir
mkdir:
 li a7, SYS_mkdir
 704:	48d1                	li	a7,20
 ecall
 706:	00000073          	ecall
 ret
 70a:	8082                	ret

000000000000070c <chdir>:
.global chdir
chdir:
 li a7, SYS_chdir
 70c:	48a5                	li	a7,9
 ecall
 70e:	00000073          	ecall
 ret
 712:	8082                	ret

0000000000000714 <dup>:
.global dup
dup:
 li a7, SYS_dup
 714:	48a9                	li	a7,10
 ecall
 716:	00000073          	ecall
 ret
 71a:	8082                	ret

000000000000071c <getpid>:
.global getpid
getpid:
 li a7, SYS_getpid
 71c:	48ad                	li	a7,11
 ecall
 71e:	00000073          	ecall
 ret
 722:	8082                	ret

0000000000000724 <sbrk>:
.global sbrk
sbrk:
 li a7, SYS_sbrk
 724:	48b1                	li	a7,12
 ecall
 726:	00000073          	ecall
 ret
 72a:	8082                	ret

000000000000072c <sleep>:
.global sleep
sleep:
 li a7, SYS_sleep
 72c:	48b5                	li	a7,13
 ecall
 72e:	00000073          	ecall
 ret
 732:	8082                	ret

0000000000000734 <uptime>:
.global uptime
uptime:
 li a7, SYS_uptime
 734:	48b9                	li	a7,14
 ecall
 736:	00000073          	ecall
 ret
 73a:	8082                	ret

000000000000073c <trace>:
.global trace
trace:
 li a7, SYS_trace
 73c:	48d9                	li	a7,22
 ecall
 73e:	00000073          	ecall
 ret
 742:	8082                	ret

0000000000000744 <sysinfo>:
.global sysinfo
sysinfo:
 li a7, SYS_sysinfo
 744:	48dd                	li	a7,23
 ecall
 746:	00000073          	ecall
 ret
 74a:	8082                	ret

000000000000074c <putc>:

static char digits[] = "0123456789ABCDEF";

static void
putc(int fd, char c)
{
 74c:	1101                	addi	sp,sp,-32
 74e:	ec06                	sd	ra,24(sp)
 750:	e822                	sd	s0,16(sp)
 752:	1000                	addi	s0,sp,32
 754:	87aa                	mv	a5,a0
 756:	872e                	mv	a4,a1
 758:	fef42623          	sw	a5,-20(s0)
 75c:	87ba                	mv	a5,a4
 75e:	fef405a3          	sb	a5,-21(s0)
  write(fd, &c, 1);
 762:	feb40713          	addi	a4,s0,-21
 766:	fec42783          	lw	a5,-20(s0)
 76a:	4605                	li	a2,1
 76c:	85ba                	mv	a1,a4
 76e:	853e                	mv	a0,a5
 770:	00000097          	auipc	ra,0x0
 774:	f4c080e7          	jalr	-180(ra) # 6bc <write>
}
 778:	0001                	nop
 77a:	60e2                	ld	ra,24(sp)
 77c:	6442                	ld	s0,16(sp)
 77e:	6105                	addi	sp,sp,32
 780:	8082                	ret

0000000000000782 <printint>:

static void
printint(int fd, int xx, int base, int sgn)
{
 782:	7139                	addi	sp,sp,-64
 784:	fc06                	sd	ra,56(sp)
 786:	f822                	sd	s0,48(sp)
 788:	0080                	addi	s0,sp,64
 78a:	87aa                	mv	a5,a0
 78c:	8736                	mv	a4,a3
 78e:	fcf42623          	sw	a5,-52(s0)
 792:	87ae                	mv	a5,a1
 794:	fcf42423          	sw	a5,-56(s0)
 798:	87b2                	mv	a5,a2
 79a:	fcf42223          	sw	a5,-60(s0)
 79e:	87ba                	mv	a5,a4
 7a0:	fcf42023          	sw	a5,-64(s0)
  char buf[16];
  int i, neg;
  uint x;

  neg = 0;
 7a4:	fe042423          	sw	zero,-24(s0)
  if(sgn && xx < 0){
 7a8:	fc042783          	lw	a5,-64(s0)
 7ac:	2781                	sext.w	a5,a5
 7ae:	c38d                	beqz	a5,7d0 <printint+0x4e>
 7b0:	fc842783          	lw	a5,-56(s0)
 7b4:	2781                	sext.w	a5,a5
 7b6:	0007dd63          	bgez	a5,7d0 <printint+0x4e>
    neg = 1;
 7ba:	4785                	li	a5,1
 7bc:	fef42423          	sw	a5,-24(s0)
    x = -xx;
 7c0:	fc842783          	lw	a5,-56(s0)
 7c4:	40f007bb          	negw	a5,a5
 7c8:	2781                	sext.w	a5,a5
 7ca:	fef42223          	sw	a5,-28(s0)
 7ce:	a029                	j	7d8 <printint+0x56>
  } else {
    x = xx;
 7d0:	fc842783          	lw	a5,-56(s0)
 7d4:	fef42223          	sw	a5,-28(s0)
  }

  i = 0;
 7d8:	fe042623          	sw	zero,-20(s0)
  do{
    buf[i++] = digits[x % base];
 7dc:	fc442783          	lw	a5,-60(s0)
 7e0:	fe442703          	lw	a4,-28(s0)
 7e4:	02f777bb          	remuw	a5,a4,a5
 7e8:	0007861b          	sext.w	a2,a5
 7ec:	fec42783          	lw	a5,-20(s0)
 7f0:	0017871b          	addiw	a4,a5,1
 7f4:	fee42623          	sw	a4,-20(s0)
 7f8:	00000697          	auipc	a3,0x0
 7fc:	76068693          	addi	a3,a3,1888 # f58 <digits>
 800:	02061713          	slli	a4,a2,0x20
 804:	9301                	srli	a4,a4,0x20
 806:	9736                	add	a4,a4,a3
 808:	00074703          	lbu	a4,0(a4)
 80c:	ff040693          	addi	a3,s0,-16
 810:	97b6                	add	a5,a5,a3
 812:	fee78023          	sb	a4,-32(a5)
  }while((x /= base) != 0);
 816:	fc442783          	lw	a5,-60(s0)
 81a:	fe442703          	lw	a4,-28(s0)
 81e:	02f757bb          	divuw	a5,a4,a5
 822:	fef42223          	sw	a5,-28(s0)
 826:	fe442783          	lw	a5,-28(s0)
 82a:	2781                	sext.w	a5,a5
 82c:	fbc5                	bnez	a5,7dc <printint+0x5a>
  if(neg)
 82e:	fe842783          	lw	a5,-24(s0)
 832:	2781                	sext.w	a5,a5
 834:	cf95                	beqz	a5,870 <printint+0xee>
    buf[i++] = '-';
 836:	fec42783          	lw	a5,-20(s0)
 83a:	0017871b          	addiw	a4,a5,1
 83e:	fee42623          	sw	a4,-20(s0)
 842:	ff040713          	addi	a4,s0,-16
 846:	97ba                	add	a5,a5,a4
 848:	02d00713          	li	a4,45
 84c:	fee78023          	sb	a4,-32(a5)

  while(--i >= 0)
 850:	a005                	j	870 <printint+0xee>
    putc(fd, buf[i]);
 852:	fec42783          	lw	a5,-20(s0)
 856:	ff040713          	addi	a4,s0,-16
 85a:	97ba                	add	a5,a5,a4
 85c:	fe07c703          	lbu	a4,-32(a5)
 860:	fcc42783          	lw	a5,-52(s0)
 864:	85ba                	mv	a1,a4
 866:	853e                	mv	a0,a5
 868:	00000097          	auipc	ra,0x0
 86c:	ee4080e7          	jalr	-284(ra) # 74c <putc>
  while(--i >= 0)
 870:	fec42783          	lw	a5,-20(s0)
 874:	37fd                	addiw	a5,a5,-1
 876:	fef42623          	sw	a5,-20(s0)
 87a:	fec42783          	lw	a5,-20(s0)
 87e:	2781                	sext.w	a5,a5
 880:	fc07d9e3          	bgez	a5,852 <printint+0xd0>
}
 884:	0001                	nop
 886:	0001                	nop
 888:	70e2                	ld	ra,56(sp)
 88a:	7442                	ld	s0,48(sp)
 88c:	6121                	addi	sp,sp,64
 88e:	8082                	ret

0000000000000890 <printptr>:

static void
printptr(int fd, uint64 x) {
 890:	7179                	addi	sp,sp,-48
 892:	f406                	sd	ra,40(sp)
 894:	f022                	sd	s0,32(sp)
 896:	1800                	addi	s0,sp,48
 898:	87aa                	mv	a5,a0
 89a:	fcb43823          	sd	a1,-48(s0)
 89e:	fcf42e23          	sw	a5,-36(s0)
  int i;
  putc(fd, '0');
 8a2:	fdc42783          	lw	a5,-36(s0)
 8a6:	03000593          	li	a1,48
 8aa:	853e                	mv	a0,a5
 8ac:	00000097          	auipc	ra,0x0
 8b0:	ea0080e7          	jalr	-352(ra) # 74c <putc>
  putc(fd, 'x');
 8b4:	fdc42783          	lw	a5,-36(s0)
 8b8:	07800593          	li	a1,120
 8bc:	853e                	mv	a0,a5
 8be:	00000097          	auipc	ra,0x0
 8c2:	e8e080e7          	jalr	-370(ra) # 74c <putc>
  for (i = 0; i < (sizeof(uint64) * 2); i++, x <<= 4)
 8c6:	fe042623          	sw	zero,-20(s0)
 8ca:	a82d                	j	904 <printptr+0x74>
    putc(fd, digits[x >> (sizeof(uint64) * 8 - 4)]);
 8cc:	fd043783          	ld	a5,-48(s0)
 8d0:	93f1                	srli	a5,a5,0x3c
 8d2:	00000717          	auipc	a4,0x0
 8d6:	68670713          	addi	a4,a4,1670 # f58 <digits>
 8da:	97ba                	add	a5,a5,a4
 8dc:	0007c703          	lbu	a4,0(a5)
 8e0:	fdc42783          	lw	a5,-36(s0)
 8e4:	85ba                	mv	a1,a4
 8e6:	853e                	mv	a0,a5
 8e8:	00000097          	auipc	ra,0x0
 8ec:	e64080e7          	jalr	-412(ra) # 74c <putc>
  for (i = 0; i < (sizeof(uint64) * 2); i++, x <<= 4)
 8f0:	fec42783          	lw	a5,-20(s0)
 8f4:	2785                	addiw	a5,a5,1
 8f6:	fef42623          	sw	a5,-20(s0)
 8fa:	fd043783          	ld	a5,-48(s0)
 8fe:	0792                	slli	a5,a5,0x4
 900:	fcf43823          	sd	a5,-48(s0)
 904:	fec42783          	lw	a5,-20(s0)
 908:	873e                	mv	a4,a5
 90a:	47bd                	li	a5,15
 90c:	fce7f0e3          	bgeu	a5,a4,8cc <printptr+0x3c>
}
 910:	0001                	nop
 912:	0001                	nop
 914:	70a2                	ld	ra,40(sp)
 916:	7402                	ld	s0,32(sp)
 918:	6145                	addi	sp,sp,48
 91a:	8082                	ret

000000000000091c <vprintf>:

// Print to the given fd. Only understands %d, %x, %p, %s.
void
vprintf(int fd, const char *fmt, va_list ap)
{
 91c:	715d                	addi	sp,sp,-80
 91e:	e486                	sd	ra,72(sp)
 920:	e0a2                	sd	s0,64(sp)
 922:	0880                	addi	s0,sp,80
 924:	87aa                	mv	a5,a0
 926:	fcb43023          	sd	a1,-64(s0)
 92a:	fac43c23          	sd	a2,-72(s0)
 92e:	fcf42623          	sw	a5,-52(s0)
  char *s;
  int c, i, state;

  state = 0;
 932:	fe042023          	sw	zero,-32(s0)
  for(i = 0; fmt[i]; i++){
 936:	fe042223          	sw	zero,-28(s0)
 93a:	a42d                	j	b64 <vprintf+0x248>
    c = fmt[i] & 0xff;
 93c:	fe442783          	lw	a5,-28(s0)
 940:	fc043703          	ld	a4,-64(s0)
 944:	97ba                	add	a5,a5,a4
 946:	0007c783          	lbu	a5,0(a5)
 94a:	fcf42e23          	sw	a5,-36(s0)
    if(state == 0){
 94e:	fe042783          	lw	a5,-32(s0)
 952:	2781                	sext.w	a5,a5
 954:	eb9d                	bnez	a5,98a <vprintf+0x6e>
      if(c == '%'){
 956:	fdc42783          	lw	a5,-36(s0)
 95a:	0007871b          	sext.w	a4,a5
 95e:	02500793          	li	a5,37
 962:	00f71763          	bne	a4,a5,970 <vprintf+0x54>
        state = '%';
 966:	02500793          	li	a5,37
 96a:	fef42023          	sw	a5,-32(s0)
 96e:	a2f5                	j	b5a <vprintf+0x23e>
      } else {
        putc(fd, c);
 970:	fdc42783          	lw	a5,-36(s0)
 974:	0ff7f713          	andi	a4,a5,255
 978:	fcc42783          	lw	a5,-52(s0)
 97c:	85ba                	mv	a1,a4
 97e:	853e                	mv	a0,a5
 980:	00000097          	auipc	ra,0x0
 984:	dcc080e7          	jalr	-564(ra) # 74c <putc>
 988:	aac9                	j	b5a <vprintf+0x23e>
      }
    } else if(state == '%'){
 98a:	fe042783          	lw	a5,-32(s0)
 98e:	0007871b          	sext.w	a4,a5
 992:	02500793          	li	a5,37
 996:	1cf71263          	bne	a4,a5,b5a <vprintf+0x23e>
      if(c == 'd'){
 99a:	fdc42783          	lw	a5,-36(s0)
 99e:	0007871b          	sext.w	a4,a5
 9a2:	06400793          	li	a5,100
 9a6:	02f71463          	bne	a4,a5,9ce <vprintf+0xb2>
        printint(fd, va_arg(ap, int), 10, 1);
 9aa:	fb843783          	ld	a5,-72(s0)
 9ae:	00878713          	addi	a4,a5,8
 9b2:	fae43c23          	sd	a4,-72(s0)
 9b6:	4398                	lw	a4,0(a5)
 9b8:	fcc42783          	lw	a5,-52(s0)
 9bc:	4685                	li	a3,1
 9be:	4629                	li	a2,10
 9c0:	85ba                	mv	a1,a4
 9c2:	853e                	mv	a0,a5
 9c4:	00000097          	auipc	ra,0x0
 9c8:	dbe080e7          	jalr	-578(ra) # 782 <printint>
 9cc:	a269                	j	b56 <vprintf+0x23a>
      } else if(c == 'l') {
 9ce:	fdc42783          	lw	a5,-36(s0)
 9d2:	0007871b          	sext.w	a4,a5
 9d6:	06c00793          	li	a5,108
 9da:	02f71663          	bne	a4,a5,a06 <vprintf+0xea>
        printint(fd, va_arg(ap, uint64), 10, 0);
 9de:	fb843783          	ld	a5,-72(s0)
 9e2:	00878713          	addi	a4,a5,8
 9e6:	fae43c23          	sd	a4,-72(s0)
 9ea:	639c                	ld	a5,0(a5)
 9ec:	0007871b          	sext.w	a4,a5
 9f0:	fcc42783          	lw	a5,-52(s0)
 9f4:	4681                	li	a3,0
 9f6:	4629                	li	a2,10
 9f8:	85ba                	mv	a1,a4
 9fa:	853e                	mv	a0,a5
 9fc:	00000097          	auipc	ra,0x0
 a00:	d86080e7          	jalr	-634(ra) # 782 <printint>
 a04:	aa89                	j	b56 <vprintf+0x23a>
      } else if(c == 'x') {
 a06:	fdc42783          	lw	a5,-36(s0)
 a0a:	0007871b          	sext.w	a4,a5
 a0e:	07800793          	li	a5,120
 a12:	02f71463          	bne	a4,a5,a3a <vprintf+0x11e>
        printint(fd, va_arg(ap, int), 16, 0);
 a16:	fb843783          	ld	a5,-72(s0)
 a1a:	00878713          	addi	a4,a5,8
 a1e:	fae43c23          	sd	a4,-72(s0)
 a22:	4398                	lw	a4,0(a5)
 a24:	fcc42783          	lw	a5,-52(s0)
 a28:	4681                	li	a3,0
 a2a:	4641                	li	a2,16
 a2c:	85ba                	mv	a1,a4
 a2e:	853e                	mv	a0,a5
 a30:	00000097          	auipc	ra,0x0
 a34:	d52080e7          	jalr	-686(ra) # 782 <printint>
 a38:	aa39                	j	b56 <vprintf+0x23a>
      } else if(c == 'p') {
 a3a:	fdc42783          	lw	a5,-36(s0)
 a3e:	0007871b          	sext.w	a4,a5
 a42:	07000793          	li	a5,112
 a46:	02f71263          	bne	a4,a5,a6a <vprintf+0x14e>
        printptr(fd, va_arg(ap, uint64));
 a4a:	fb843783          	ld	a5,-72(s0)
 a4e:	00878713          	addi	a4,a5,8
 a52:	fae43c23          	sd	a4,-72(s0)
 a56:	6398                	ld	a4,0(a5)
 a58:	fcc42783          	lw	a5,-52(s0)
 a5c:	85ba                	mv	a1,a4
 a5e:	853e                	mv	a0,a5
 a60:	00000097          	auipc	ra,0x0
 a64:	e30080e7          	jalr	-464(ra) # 890 <printptr>
 a68:	a0fd                	j	b56 <vprintf+0x23a>
      } else if(c == 's'){
 a6a:	fdc42783          	lw	a5,-36(s0)
 a6e:	0007871b          	sext.w	a4,a5
 a72:	07300793          	li	a5,115
 a76:	04f71c63          	bne	a4,a5,ace <vprintf+0x1b2>
        s = va_arg(ap, char*);
 a7a:	fb843783          	ld	a5,-72(s0)
 a7e:	00878713          	addi	a4,a5,8
 a82:	fae43c23          	sd	a4,-72(s0)
 a86:	639c                	ld	a5,0(a5)
 a88:	fef43423          	sd	a5,-24(s0)
        if(s == 0)
 a8c:	fe843783          	ld	a5,-24(s0)
 a90:	eb8d                	bnez	a5,ac2 <vprintf+0x1a6>
          s = "(null)";
 a92:	00000797          	auipc	a5,0x0
 a96:	4be78793          	addi	a5,a5,1214 # f50 <malloc+0x184>
 a9a:	fef43423          	sd	a5,-24(s0)
        while(*s != 0){
 a9e:	a015                	j	ac2 <vprintf+0x1a6>
          putc(fd, *s);
 aa0:	fe843783          	ld	a5,-24(s0)
 aa4:	0007c703          	lbu	a4,0(a5)
 aa8:	fcc42783          	lw	a5,-52(s0)
 aac:	85ba                	mv	a1,a4
 aae:	853e                	mv	a0,a5
 ab0:	00000097          	auipc	ra,0x0
 ab4:	c9c080e7          	jalr	-868(ra) # 74c <putc>
          s++;
 ab8:	fe843783          	ld	a5,-24(s0)
 abc:	0785                	addi	a5,a5,1
 abe:	fef43423          	sd	a5,-24(s0)
        while(*s != 0){
 ac2:	fe843783          	ld	a5,-24(s0)
 ac6:	0007c783          	lbu	a5,0(a5)
 aca:	fbf9                	bnez	a5,aa0 <vprintf+0x184>
 acc:	a069                	j	b56 <vprintf+0x23a>
        }
      } else if(c == 'c'){
 ace:	fdc42783          	lw	a5,-36(s0)
 ad2:	0007871b          	sext.w	a4,a5
 ad6:	06300793          	li	a5,99
 ada:	02f71463          	bne	a4,a5,b02 <vprintf+0x1e6>
        putc(fd, va_arg(ap, uint));
 ade:	fb843783          	ld	a5,-72(s0)
 ae2:	00878713          	addi	a4,a5,8
 ae6:	fae43c23          	sd	a4,-72(s0)
 aea:	439c                	lw	a5,0(a5)
 aec:	0ff7f713          	andi	a4,a5,255
 af0:	fcc42783          	lw	a5,-52(s0)
 af4:	85ba                	mv	a1,a4
 af6:	853e                	mv	a0,a5
 af8:	00000097          	auipc	ra,0x0
 afc:	c54080e7          	jalr	-940(ra) # 74c <putc>
 b00:	a899                	j	b56 <vprintf+0x23a>
      } else if(c == '%'){
 b02:	fdc42783          	lw	a5,-36(s0)
 b06:	0007871b          	sext.w	a4,a5
 b0a:	02500793          	li	a5,37
 b0e:	00f71f63          	bne	a4,a5,b2c <vprintf+0x210>
        putc(fd, c);
 b12:	fdc42783          	lw	a5,-36(s0)
 b16:	0ff7f713          	andi	a4,a5,255
 b1a:	fcc42783          	lw	a5,-52(s0)
 b1e:	85ba                	mv	a1,a4
 b20:	853e                	mv	a0,a5
 b22:	00000097          	auipc	ra,0x0
 b26:	c2a080e7          	jalr	-982(ra) # 74c <putc>
 b2a:	a035                	j	b56 <vprintf+0x23a>
      } else {
        // Unknown % sequence.  Print it to draw attention.
        putc(fd, '%');
 b2c:	fcc42783          	lw	a5,-52(s0)
 b30:	02500593          	li	a1,37
 b34:	853e                	mv	a0,a5
 b36:	00000097          	auipc	ra,0x0
 b3a:	c16080e7          	jalr	-1002(ra) # 74c <putc>
        putc(fd, c);
 b3e:	fdc42783          	lw	a5,-36(s0)
 b42:	0ff7f713          	andi	a4,a5,255
 b46:	fcc42783          	lw	a5,-52(s0)
 b4a:	85ba                	mv	a1,a4
 b4c:	853e                	mv	a0,a5
 b4e:	00000097          	auipc	ra,0x0
 b52:	bfe080e7          	jalr	-1026(ra) # 74c <putc>
      }
      state = 0;
 b56:	fe042023          	sw	zero,-32(s0)
  for(i = 0; fmt[i]; i++){
 b5a:	fe442783          	lw	a5,-28(s0)
 b5e:	2785                	addiw	a5,a5,1
 b60:	fef42223          	sw	a5,-28(s0)
 b64:	fe442783          	lw	a5,-28(s0)
 b68:	fc043703          	ld	a4,-64(s0)
 b6c:	97ba                	add	a5,a5,a4
 b6e:	0007c783          	lbu	a5,0(a5)
 b72:	dc0795e3          	bnez	a5,93c <vprintf+0x20>
    }
  }
}
 b76:	0001                	nop
 b78:	0001                	nop
 b7a:	60a6                	ld	ra,72(sp)
 b7c:	6406                	ld	s0,64(sp)
 b7e:	6161                	addi	sp,sp,80
 b80:	8082                	ret

0000000000000b82 <fprintf>:

void
fprintf(int fd, const char *fmt, ...)
{
 b82:	7159                	addi	sp,sp,-112
 b84:	fc06                	sd	ra,56(sp)
 b86:	f822                	sd	s0,48(sp)
 b88:	0080                	addi	s0,sp,64
 b8a:	fcb43823          	sd	a1,-48(s0)
 b8e:	e010                	sd	a2,0(s0)
 b90:	e414                	sd	a3,8(s0)
 b92:	e818                	sd	a4,16(s0)
 b94:	ec1c                	sd	a5,24(s0)
 b96:	03043023          	sd	a6,32(s0)
 b9a:	03143423          	sd	a7,40(s0)
 b9e:	87aa                	mv	a5,a0
 ba0:	fcf42e23          	sw	a5,-36(s0)
  va_list ap;

  va_start(ap, fmt);
 ba4:	03040793          	addi	a5,s0,48
 ba8:	fcf43423          	sd	a5,-56(s0)
 bac:	fc843783          	ld	a5,-56(s0)
 bb0:	fd078793          	addi	a5,a5,-48
 bb4:	fef43423          	sd	a5,-24(s0)
  vprintf(fd, fmt, ap);
 bb8:	fe843703          	ld	a4,-24(s0)
 bbc:	fdc42783          	lw	a5,-36(s0)
 bc0:	863a                	mv	a2,a4
 bc2:	fd043583          	ld	a1,-48(s0)
 bc6:	853e                	mv	a0,a5
 bc8:	00000097          	auipc	ra,0x0
 bcc:	d54080e7          	jalr	-684(ra) # 91c <vprintf>
}
 bd0:	0001                	nop
 bd2:	70e2                	ld	ra,56(sp)
 bd4:	7442                	ld	s0,48(sp)
 bd6:	6165                	addi	sp,sp,112
 bd8:	8082                	ret

0000000000000bda <printf>:

void
printf(const char *fmt, ...)
{
 bda:	7159                	addi	sp,sp,-112
 bdc:	f406                	sd	ra,40(sp)
 bde:	f022                	sd	s0,32(sp)
 be0:	1800                	addi	s0,sp,48
 be2:	fca43c23          	sd	a0,-40(s0)
 be6:	e40c                	sd	a1,8(s0)
 be8:	e810                	sd	a2,16(s0)
 bea:	ec14                	sd	a3,24(s0)
 bec:	f018                	sd	a4,32(s0)
 bee:	f41c                	sd	a5,40(s0)
 bf0:	03043823          	sd	a6,48(s0)
 bf4:	03143c23          	sd	a7,56(s0)
  va_list ap;

  va_start(ap, fmt);
 bf8:	04040793          	addi	a5,s0,64
 bfc:	fcf43823          	sd	a5,-48(s0)
 c00:	fd043783          	ld	a5,-48(s0)
 c04:	fc878793          	addi	a5,a5,-56
 c08:	fef43423          	sd	a5,-24(s0)
  vprintf(1, fmt, ap);
 c0c:	fe843783          	ld	a5,-24(s0)
 c10:	863e                	mv	a2,a5
 c12:	fd843583          	ld	a1,-40(s0)
 c16:	4505                	li	a0,1
 c18:	00000097          	auipc	ra,0x0
 c1c:	d04080e7          	jalr	-764(ra) # 91c <vprintf>
}
 c20:	0001                	nop
 c22:	70a2                	ld	ra,40(sp)
 c24:	7402                	ld	s0,32(sp)
 c26:	6165                	addi	sp,sp,112
 c28:	8082                	ret

0000000000000c2a <free>:
static Header base;
static Header *freep;

void
free(void *ap)
{
 c2a:	7179                	addi	sp,sp,-48
 c2c:	f422                	sd	s0,40(sp)
 c2e:	1800                	addi	s0,sp,48
 c30:	fca43c23          	sd	a0,-40(s0)
  Header *bp, *p;

  bp = (Header*)ap - 1;
 c34:	fd843783          	ld	a5,-40(s0)
 c38:	17c1                	addi	a5,a5,-16
 c3a:	fef43023          	sd	a5,-32(s0)
  for(p = freep; !(bp > p && bp < p->s.ptr); p = p->s.ptr)
 c3e:	00000797          	auipc	a5,0x0
 c42:	34278793          	addi	a5,a5,834 # f80 <freep>
 c46:	639c                	ld	a5,0(a5)
 c48:	fef43423          	sd	a5,-24(s0)
 c4c:	a815                	j	c80 <free+0x56>
    if(p >= p->s.ptr && (bp > p || bp < p->s.ptr))
 c4e:	fe843783          	ld	a5,-24(s0)
 c52:	639c                	ld	a5,0(a5)
 c54:	fe843703          	ld	a4,-24(s0)
 c58:	00f76f63          	bltu	a4,a5,c76 <free+0x4c>
 c5c:	fe043703          	ld	a4,-32(s0)
 c60:	fe843783          	ld	a5,-24(s0)
 c64:	02e7eb63          	bltu	a5,a4,c9a <free+0x70>
 c68:	fe843783          	ld	a5,-24(s0)
 c6c:	639c                	ld	a5,0(a5)
 c6e:	fe043703          	ld	a4,-32(s0)
 c72:	02f76463          	bltu	a4,a5,c9a <free+0x70>
  for(p = freep; !(bp > p && bp < p->s.ptr); p = p->s.ptr)
 c76:	fe843783          	ld	a5,-24(s0)
 c7a:	639c                	ld	a5,0(a5)
 c7c:	fef43423          	sd	a5,-24(s0)
 c80:	fe043703          	ld	a4,-32(s0)
 c84:	fe843783          	ld	a5,-24(s0)
 c88:	fce7f3e3          	bgeu	a5,a4,c4e <free+0x24>
 c8c:	fe843783          	ld	a5,-24(s0)
 c90:	639c                	ld	a5,0(a5)
 c92:	fe043703          	ld	a4,-32(s0)
 c96:	faf77ce3          	bgeu	a4,a5,c4e <free+0x24>
      break;
  if(bp + bp->s.size == p->s.ptr){
 c9a:	fe043783          	ld	a5,-32(s0)
 c9e:	479c                	lw	a5,8(a5)
 ca0:	1782                	slli	a5,a5,0x20
 ca2:	9381                	srli	a5,a5,0x20
 ca4:	0792                	slli	a5,a5,0x4
 ca6:	fe043703          	ld	a4,-32(s0)
 caa:	973e                	add	a4,a4,a5
 cac:	fe843783          	ld	a5,-24(s0)
 cb0:	639c                	ld	a5,0(a5)
 cb2:	02f71763          	bne	a4,a5,ce0 <free+0xb6>
    bp->s.size += p->s.ptr->s.size;
 cb6:	fe043783          	ld	a5,-32(s0)
 cba:	4798                	lw	a4,8(a5)
 cbc:	fe843783          	ld	a5,-24(s0)
 cc0:	639c                	ld	a5,0(a5)
 cc2:	479c                	lw	a5,8(a5)
 cc4:	9fb9                	addw	a5,a5,a4
 cc6:	0007871b          	sext.w	a4,a5
 cca:	fe043783          	ld	a5,-32(s0)
 cce:	c798                	sw	a4,8(a5)
    bp->s.ptr = p->s.ptr->s.ptr;
 cd0:	fe843783          	ld	a5,-24(s0)
 cd4:	639c                	ld	a5,0(a5)
 cd6:	6398                	ld	a4,0(a5)
 cd8:	fe043783          	ld	a5,-32(s0)
 cdc:	e398                	sd	a4,0(a5)
 cde:	a039                	j	cec <free+0xc2>
  } else
    bp->s.ptr = p->s.ptr;
 ce0:	fe843783          	ld	a5,-24(s0)
 ce4:	6398                	ld	a4,0(a5)
 ce6:	fe043783          	ld	a5,-32(s0)
 cea:	e398                	sd	a4,0(a5)
  if(p + p->s.size == bp){
 cec:	fe843783          	ld	a5,-24(s0)
 cf0:	479c                	lw	a5,8(a5)
 cf2:	1782                	slli	a5,a5,0x20
 cf4:	9381                	srli	a5,a5,0x20
 cf6:	0792                	slli	a5,a5,0x4
 cf8:	fe843703          	ld	a4,-24(s0)
 cfc:	97ba                	add	a5,a5,a4
 cfe:	fe043703          	ld	a4,-32(s0)
 d02:	02f71563          	bne	a4,a5,d2c <free+0x102>
    p->s.size += bp->s.size;
 d06:	fe843783          	ld	a5,-24(s0)
 d0a:	4798                	lw	a4,8(a5)
 d0c:	fe043783          	ld	a5,-32(s0)
 d10:	479c                	lw	a5,8(a5)
 d12:	9fb9                	addw	a5,a5,a4
 d14:	0007871b          	sext.w	a4,a5
 d18:	fe843783          	ld	a5,-24(s0)
 d1c:	c798                	sw	a4,8(a5)
    p->s.ptr = bp->s.ptr;
 d1e:	fe043783          	ld	a5,-32(s0)
 d22:	6398                	ld	a4,0(a5)
 d24:	fe843783          	ld	a5,-24(s0)
 d28:	e398                	sd	a4,0(a5)
 d2a:	a031                	j	d36 <free+0x10c>
  } else
    p->s.ptr = bp;
 d2c:	fe843783          	ld	a5,-24(s0)
 d30:	fe043703          	ld	a4,-32(s0)
 d34:	e398                	sd	a4,0(a5)
  freep = p;
 d36:	00000797          	auipc	a5,0x0
 d3a:	24a78793          	addi	a5,a5,586 # f80 <freep>
 d3e:	fe843703          	ld	a4,-24(s0)
 d42:	e398                	sd	a4,0(a5)
}
 d44:	0001                	nop
 d46:	7422                	ld	s0,40(sp)
 d48:	6145                	addi	sp,sp,48
 d4a:	8082                	ret

0000000000000d4c <morecore>:

static Header*
morecore(uint nu)
{
 d4c:	7179                	addi	sp,sp,-48
 d4e:	f406                	sd	ra,40(sp)
 d50:	f022                	sd	s0,32(sp)
 d52:	1800                	addi	s0,sp,48
 d54:	87aa                	mv	a5,a0
 d56:	fcf42e23          	sw	a5,-36(s0)
  char *p;
  Header *hp;

  if(nu < 4096)
 d5a:	fdc42783          	lw	a5,-36(s0)
 d5e:	0007871b          	sext.w	a4,a5
 d62:	6785                	lui	a5,0x1
 d64:	00f77563          	bgeu	a4,a5,d6e <morecore+0x22>
    nu = 4096;
 d68:	6785                	lui	a5,0x1
 d6a:	fcf42e23          	sw	a5,-36(s0)
  p = sbrk(nu * sizeof(Header));
 d6e:	fdc42783          	lw	a5,-36(s0)
 d72:	0047979b          	slliw	a5,a5,0x4
 d76:	2781                	sext.w	a5,a5
 d78:	2781                	sext.w	a5,a5
 d7a:	853e                	mv	a0,a5
 d7c:	00000097          	auipc	ra,0x0
 d80:	9a8080e7          	jalr	-1624(ra) # 724 <sbrk>
 d84:	fea43423          	sd	a0,-24(s0)
  if(p == (char*)-1)
 d88:	fe843703          	ld	a4,-24(s0)
 d8c:	57fd                	li	a5,-1
 d8e:	00f71463          	bne	a4,a5,d96 <morecore+0x4a>
    return 0;
 d92:	4781                	li	a5,0
 d94:	a03d                	j	dc2 <morecore+0x76>
  hp = (Header*)p;
 d96:	fe843783          	ld	a5,-24(s0)
 d9a:	fef43023          	sd	a5,-32(s0)
  hp->s.size = nu;
 d9e:	fe043783          	ld	a5,-32(s0)
 da2:	fdc42703          	lw	a4,-36(s0)
 da6:	c798                	sw	a4,8(a5)
  free((void*)(hp + 1));
 da8:	fe043783          	ld	a5,-32(s0)
 dac:	07c1                	addi	a5,a5,16
 dae:	853e                	mv	a0,a5
 db0:	00000097          	auipc	ra,0x0
 db4:	e7a080e7          	jalr	-390(ra) # c2a <free>
  return freep;
 db8:	00000797          	auipc	a5,0x0
 dbc:	1c878793          	addi	a5,a5,456 # f80 <freep>
 dc0:	639c                	ld	a5,0(a5)
}
 dc2:	853e                	mv	a0,a5
 dc4:	70a2                	ld	ra,40(sp)
 dc6:	7402                	ld	s0,32(sp)
 dc8:	6145                	addi	sp,sp,48
 dca:	8082                	ret

0000000000000dcc <malloc>:

void*
malloc(uint nbytes)
{
 dcc:	7139                	addi	sp,sp,-64
 dce:	fc06                	sd	ra,56(sp)
 dd0:	f822                	sd	s0,48(sp)
 dd2:	0080                	addi	s0,sp,64
 dd4:	87aa                	mv	a5,a0
 dd6:	fcf42623          	sw	a5,-52(s0)
  Header *p, *prevp;
  uint nunits;

  nunits = (nbytes + sizeof(Header) - 1)/sizeof(Header) + 1;
 dda:	fcc46783          	lwu	a5,-52(s0)
 dde:	07bd                	addi	a5,a5,15
 de0:	8391                	srli	a5,a5,0x4
 de2:	2781                	sext.w	a5,a5
 de4:	2785                	addiw	a5,a5,1
 de6:	fcf42e23          	sw	a5,-36(s0)
  if((prevp = freep) == 0){
 dea:	00000797          	auipc	a5,0x0
 dee:	19678793          	addi	a5,a5,406 # f80 <freep>
 df2:	639c                	ld	a5,0(a5)
 df4:	fef43023          	sd	a5,-32(s0)
 df8:	fe043783          	ld	a5,-32(s0)
 dfc:	ef95                	bnez	a5,e38 <malloc+0x6c>
    base.s.ptr = freep = prevp = &base;
 dfe:	00000797          	auipc	a5,0x0
 e02:	17278793          	addi	a5,a5,370 # f70 <base>
 e06:	fef43023          	sd	a5,-32(s0)
 e0a:	00000797          	auipc	a5,0x0
 e0e:	17678793          	addi	a5,a5,374 # f80 <freep>
 e12:	fe043703          	ld	a4,-32(s0)
 e16:	e398                	sd	a4,0(a5)
 e18:	00000797          	auipc	a5,0x0
 e1c:	16878793          	addi	a5,a5,360 # f80 <freep>
 e20:	6398                	ld	a4,0(a5)
 e22:	00000797          	auipc	a5,0x0
 e26:	14e78793          	addi	a5,a5,334 # f70 <base>
 e2a:	e398                	sd	a4,0(a5)
    base.s.size = 0;
 e2c:	00000797          	auipc	a5,0x0
 e30:	14478793          	addi	a5,a5,324 # f70 <base>
 e34:	0007a423          	sw	zero,8(a5)
  }
  for(p = prevp->s.ptr; ; prevp = p, p = p->s.ptr){
 e38:	fe043783          	ld	a5,-32(s0)
 e3c:	639c                	ld	a5,0(a5)
 e3e:	fef43423          	sd	a5,-24(s0)
    if(p->s.size >= nunits){
 e42:	fe843783          	ld	a5,-24(s0)
 e46:	4798                	lw	a4,8(a5)
 e48:	fdc42783          	lw	a5,-36(s0)
 e4c:	2781                	sext.w	a5,a5
 e4e:	06f76863          	bltu	a4,a5,ebe <malloc+0xf2>
      if(p->s.size == nunits)
 e52:	fe843783          	ld	a5,-24(s0)
 e56:	4798                	lw	a4,8(a5)
 e58:	fdc42783          	lw	a5,-36(s0)
 e5c:	2781                	sext.w	a5,a5
 e5e:	00e79963          	bne	a5,a4,e70 <malloc+0xa4>
        prevp->s.ptr = p->s.ptr;
 e62:	fe843783          	ld	a5,-24(s0)
 e66:	6398                	ld	a4,0(a5)
 e68:	fe043783          	ld	a5,-32(s0)
 e6c:	e398                	sd	a4,0(a5)
 e6e:	a82d                	j	ea8 <malloc+0xdc>
      else {
        p->s.size -= nunits;
 e70:	fe843783          	ld	a5,-24(s0)
 e74:	4798                	lw	a4,8(a5)
 e76:	fdc42783          	lw	a5,-36(s0)
 e7a:	40f707bb          	subw	a5,a4,a5
 e7e:	0007871b          	sext.w	a4,a5
 e82:	fe843783          	ld	a5,-24(s0)
 e86:	c798                	sw	a4,8(a5)
        p += p->s.size;
 e88:	fe843783          	ld	a5,-24(s0)
 e8c:	479c                	lw	a5,8(a5)
 e8e:	1782                	slli	a5,a5,0x20
 e90:	9381                	srli	a5,a5,0x20
 e92:	0792                	slli	a5,a5,0x4
 e94:	fe843703          	ld	a4,-24(s0)
 e98:	97ba                	add	a5,a5,a4
 e9a:	fef43423          	sd	a5,-24(s0)
        p->s.size = nunits;
 e9e:	fe843783          	ld	a5,-24(s0)
 ea2:	fdc42703          	lw	a4,-36(s0)
 ea6:	c798                	sw	a4,8(a5)
      }
      freep = prevp;
 ea8:	00000797          	auipc	a5,0x0
 eac:	0d878793          	addi	a5,a5,216 # f80 <freep>
 eb0:	fe043703          	ld	a4,-32(s0)
 eb4:	e398                	sd	a4,0(a5)
      return (void*)(p + 1);
 eb6:	fe843783          	ld	a5,-24(s0)
 eba:	07c1                	addi	a5,a5,16
 ebc:	a091                	j	f00 <malloc+0x134>
    }
    if(p == freep)
 ebe:	00000797          	auipc	a5,0x0
 ec2:	0c278793          	addi	a5,a5,194 # f80 <freep>
 ec6:	639c                	ld	a5,0(a5)
 ec8:	fe843703          	ld	a4,-24(s0)
 ecc:	02f71063          	bne	a4,a5,eec <malloc+0x120>
      if((p = morecore(nunits)) == 0)
 ed0:	fdc42783          	lw	a5,-36(s0)
 ed4:	853e                	mv	a0,a5
 ed6:	00000097          	auipc	ra,0x0
 eda:	e76080e7          	jalr	-394(ra) # d4c <morecore>
 ede:	fea43423          	sd	a0,-24(s0)
 ee2:	fe843783          	ld	a5,-24(s0)
 ee6:	e399                	bnez	a5,eec <malloc+0x120>
        return 0;
 ee8:	4781                	li	a5,0
 eea:	a819                	j	f00 <malloc+0x134>
  for(p = prevp->s.ptr; ; prevp = p, p = p->s.ptr){
 eec:	fe843783          	ld	a5,-24(s0)
 ef0:	fef43023          	sd	a5,-32(s0)
 ef4:	fe843783          	ld	a5,-24(s0)
 ef8:	639c                	ld	a5,0(a5)
 efa:	fef43423          	sd	a5,-24(s0)
    if(p->s.size >= nunits){
 efe:	b791                	j	e42 <malloc+0x76>
  }
}
 f00:	853e                	mv	a0,a5
 f02:	70e2                	ld	ra,56(sp)
 f04:	7442                	ld	s0,48(sp)
 f06:	6121                	addi	sp,sp,64
 f08:	8082                	ret
